# -*- coding: utf8 -*-
from __future__ import division

import os, glob, sys
from PIL import Image, ImageFont, ImageDraw

textos = [
    (100, u"Paseo por Maranello"),
    (35, u"Hogar de la Ferrari, en Módena"), 
]

firmas = [
    "Facundo Batista  -  Licencia Creative Commons BY-NC-ND",
    "Este video fue hecho con Software Libre: dvgrab, kino y Python",
]

# son 25 FPS
# FIXME
FRAMES_SHOW = 60
FRAMES_FADEOUT = 20

(IMGW, IMGH) = (1024,768)
INIY = IMGH * .2
INTERLINEA = 1.2
POSFIRMA = IMGH * .9

# prepare the fonts
fonts = {}
for size in set(x[0] for x in textos):
    font = ImageFont.truetype("fonts/RaspoutineClassic_TB.otf", size, encoding="unic")
    fonts[size] = font
firmafont = ImageFont.truetype("fonts/laCartoonerie.ttf", 30, encoding="unic")

negra = Image.new("RGB", (IMGW, IMGH), (0,0,0))
#negra.save("negra.jpg", "JPEG")

def blend(img, factor):
    print "blend", factor
    return Image.blend(img, negra, factor)

def dibuja():
    # build the image
    img = Image.new("RGB", (IMGW, IMGH), (0,0,0))
    draw = ImageDraw.Draw(img)

    # textos titulos
    posy = INIY
    for tam, texto in textos:
        font = fonts[tam]
        (ancho, alto) = font.getsize(texto)
        inix = IMGW/2 - ancho/2
        draw.text((inix,posy), texto, font=font)
        posy += (alto*INTERLINEA)

    # textos firma
    posy = POSFIRMA
    for texto in firmas:
        (ancho, alto) = firmafont.getsize(texto)
        inix = IMGW/2 - ancho/2
        draw.text((inix,posy), texto, font=firmafont)
        posy += (alto*INTERLINEA)

    # generate fixed one
    for i in xrange(FRAMES_SHOW):
        yield img

    # generate fade out
    paso = 1 / FRAMES_FADEOUT
    for i in xrange(FRAMES_FADEOUT):
        faded = blend(img, paso*i)
        yield faded

demo = (len(sys.argv) == 2 and sys.argv[1] == "--demo")

for i,img in enumerate(dibuja()):
    nom = "tmp_frames/titul%05d.jpg" % i
    img.save(nom, "JPEG")
    if demo:
        sys.exit()
    print nom

cmd = 'mencoder "mf://tmp_frames/*.jpg" -ovc lavc -o tmp.avi -lavcopts vcodec=mjpeg:vbitrate=1152'
os.system(cmd)
cmd = "ffmpeg -i tmp.avi -target pal-dv titulos.dv"
os.system(cmd)

# remove temp files
for nomarch in glob.glob("tmp_frames/titul?????.jpg"):
    os.remove(nomarch)
os.remove("tmp.avi")
